package edu.saldcomp.hot;

import io.reactivex.BackpressureStrategy;
import io.reactivex.Flowable;
import io.reactivex.Observable;
import io.reactivex.schedulers.Schedulers;
import io.reactivex.subjects.PublishSubject;
import io.reactivex.subscribers.DefaultSubscriber;
import org.reactivestreams.Subscriber;

import javax.xml.crypto.Data;
import java.util.List;
import java.util.concurrent.TimeUnit;
import java.util.stream.IntStream;

public class HotMain {

    public static void main(String[] args) throws InterruptedException {

        var observable = PublishSubject.<Integer>create();
        observable
                .toFlowable(BackpressureStrategy.MISSING)
                .onBackpressureDrop()
                .observeOn(Schedulers.newThread())
                .subscribeOn(Schedulers.newThread())
                .subscribe(
                        ComputeFunction::compute,
                        (t)-> System.out.println(t)
                );

        IntStream.range(0, 1000000)
                 .forEach(i -> observable.onNext(i));

        Thread.sleep(20000);

    }

    public interface ComputeFunction {
        static void compute(Integer v) {
            try {
                System.out.println("compute integer v: " + v);
                Thread.sleep(3000);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
    }

}
